#!/bin/bash -x
#===============================================================================
#
#          FILE: run.sh
# 
#         USAGE: ./run.sh 
# 
#   DESCRIPTION: 
# 
#       OPTIONS: ---
#  REQUIREMENTS: ---
#          BUGS: ---

#  ORGANIZATION: 
#       CREATED: 02/28/2017 17:20
#      REVISION:  ---
#===============================================================================

set -o nounset                              # Treat unset variables as an error
DOM=BZ1292984
DISK_PATH=/var/lib/libvirt/images/$DOM.qcow2
prep(){
    augtool set /files/etc/libvirt/qemu.conf/lock_manager "sanlock"
    augtool set /files/etc/libvirt/qemu-sanlock.conf/user "sanlock"
    augtool set /files/etc/libvirt/qemu-sanlock.conf/group "sanlock"
    augtool set /files/etc/libvirt/qemu-sanlock.conf/host_id 1 
    augtool set /files/etc/libvirt/qemu-sanlock.conf/auto_disk_leases 1 
    augtool set /files/etc/libvirt/qemu-sanlock.conf/disk_lease_dir "/var/lib/libvirt/sanlock"
    augtool set /files/etc/libvirt/qemu-sanlock.conf/io_timeout $1
    systemctl restart sanlock
    systemctl restart libvirtd
    if [ ! -f $DISK_PATH ];then
        cp /var/lib/libvirt/images/V.qcow2 $DISK_PATH
    fi
    virt-install --transient --import -n $DOM -r 1024 --disk $DISK_PATH --noautoconsole
}

cleanup(){
    virsh destroy $DOM
    augtool rm /files/etc/libvirt/qemu.conf/lock_manager
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/user
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/group
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/host_id
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/auto_disk_leases
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/disk_lease_dir
    augtool rm /files/etc/libvirt/qemu-sanlock.conf/io_timeout
    systemctl restart libvirtd
}
#yum install augeas libvirt virt-install qemu-kvm-rhev ltrace -y
for io_timeout in $(seq 50 2 200);do
    prep $io_timeout
    sleep 10
    shred /var/lib/libvirt/sanlock/*
    rm /var/lib/libvirt/sanlock/*
    START_TIME=$(date +%s)
    while true;do
        pgrep -f $DOM
        if [ $? -ne 0 ];then
            END_TIME=$(date +%s)
        fi
    done
    echo $END_TIME-$START_TIME |bc |tee -a /tmp/io_timeout.log
    cleanup
done
trap cleanup SIGINT
rm $DISK_PATH
ausearch -m AVC --ts $DATE1 $TIME1
